<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Predict Image</title>
</head>
<body>
    <h1>Upload Image for Prediction</h1>
    <form id="imageForm" enctype="multipart/form-data" method="POST" action="http://localhost:5000/predict">
        <input type="file" name="image" accept="image/*">
        <button type="submit">Predict</button>
    </form>

    <div id="predictionResult">
        <!-- Prediction result will be displayed here -->
    </div>

    <div id="imageDisplay">
        <!-- Image will be displayed here -->
    </div>

    <script>
        // Handle form submission
        const form = document.getElementById('imageForm');
        form.addEventListener('submit', async (event) => {
            event.preventDefault(); // Prevent default form submission
            const formData = new FormData(form); // Get form data
            try {
                const response = await fetch('http://localhost:5000/predict', {
                    method: 'POST',
                    body: formData
                });
                if (!response.ok) {
                    throw new Error('Prediction failed');
                }
                const result = await response.json(); // Parse JSON response
                displayPredictionResult(result); // Display prediction result
            } catch (error) {
                console.error('Error:', error);
            }
        });

        // Function to display prediction result
        function displayPredictionResult(result) {
            const predictionDiv = document.getElementById('predictionResult');
            predictionDiv.innerHTML = `
                <h2>Prediction Result:</h2>
                <p>Predicted Class: ${result.predicted_class}</p>
                <p>Prediction: ${JSON.stringify(result.prediction)}</p>
            `;

            // Display the uploaded image
            const imageDisplayDiv = document.getElementById('imageDisplay');
            const imageElement = document.createElement('img');
            imageElement.src = URL.createObjectURL(form.elements.image.files[0]);
            imageElement.width = 300;
            imageElement.height = 200;
            imageDisplayDiv.innerHTML = ''; // Clear previous image
            imageDisplayDiv.appendChild(imageElement);
        }
    </script>
</body>
</html>
